<?php

class ChargingAPIServices
{
    

    public function encrypt($data, $secret)
    {
        //Generate a key from a hash
        $key = md5(utf8_encode($secret), true);

        //Take first 8 bytes of $key and append them to the end of $key.
        $key .= substr($key, 0, 8);

        //Pad for PKCS7
        $blockSize = mcrypt_get_block_size('tripledes', 'ecb');
        $len = strlen($data);
        $pad = $blockSize - ($len % $blockSize);
        $data .= str_repeat(chr($pad), $pad);

        //Encrypt data
        $encData = mcrypt_encrypt('tripledes', $key, $data, 'ecb');

        return base64_encode($encData);
    }

    public function decrypt($data, $secret)
    {
        //Generate a key from a hash
        $key = md5(utf8_encode($secret), true);

        //Take first 8 bytes of $key and append them to the end of $key.
        $key .= substr($key, 0, 8);

        $data = base64_decode($data);

        $data = mcrypt_decrypt('tripledes', $key, $data, 'ecb');

        $block = mcrypt_get_block_size('tripledes', 'ecb');
        $len = strlen($data);
        $pad = ord($data[$len - 1]);

        return substr($data, 0, strlen($data) - $pad);
    }


    public function CallService($request_id,$telecom,$amount,$quantity,$service_id){
        include_once(app_path() . '/config.php');

        $sign = md5($hash_id . $parter_key . $service_id . $request_id);

        $data['hash_id'] = $hash_id;
        $data['parter_key'] = $parter_key;
        $data['request_id'] = $request_id;
        $data['telecom_key'] = $telecom;
        $data['amount'] = $amount;
        $data['quantity'] = $quantity;
        $data['sign'] = $sign;

        if (is_array($data)) {
            $dataPost = http_build_query($data);
        } else {
            $dataPost = $data;
        }

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $dataPost);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, 300); //THÊM DÒNG NÀY SẼ TĂNG THỜI GIAN GỬI THẺ ĐƯỢC ỔN ĐỊNH
        $resultRaw = curl_exec($ch);
        curl_close($ch);
        $obj = json_decode($resultRaw);

        return $obj;

    }
}

?>